local M = {}

local helper = require('scenario/scenariohelper')
local running = false
local scenario = nil

local redLap
local blueLap
local greenLap
local yellowLap

local redCheck
local blueCheck
local greenCheck
local yellowCheck

redCar = scenetree.findObject('RedCar')
blueCar = scenetree.findObject('BlueCar')
greenCar = scenetree.findObject('GreenCar')
yellowCar = scenetree.findObject('YellowCar')

local lapCount
local scenarioCam = nil

local function setCam()
	scenarioCam = scenetree.findObject('RaceCam')
	commands.setFreeCamera()
	local game = commands.getGame()
    local camera = commands.getCamera(game)
	camera:setTransform(scenarioCam:getTransform())
end

local function reset()
    running = false
end

local function onRaceStart()
	reset()
	running = true
	
	redLap = 1
	blueLap = 1
	greenLap = 1
	yellowLap = 1
	
	redCheck = 0
	blueCheck = 0
	greenCheck = 0
	yellowCheck = 0
	
	lapCount = 3
	setCam()
end


local function success(data)
	local result = {msg = 'The '..data..' car wins!'}
	scenario_scenarios.finish(result)
end

local function fail(reason)
  scenario_scenarios.finish({failed = reason})
  reset()
end

function onStartLine(data)
	if data.subjectName == 'RedCar' and redCheck == 2 then
		if redLap < lapCount then
			redCheck = 0
			redLap = redLap + 1
			helper.flashUiMessage('Red Lap!', 3)
		elseif redLap >= lapCount then
			success('red')
		end
	elseif data.subjectName == 'BlueCar' and blueCheck == 2 then
		if blueLap < lapCount then
			blueCheck = 0
			blueLap = blueLap + 1
			helper.flashUiMessage('Blue Lap!', 3)
		elseif blueLap >= lapCount then
			success('blue')
		end
	elseif data.subjectName == 'GreenCar' and greenCheck == 2 then
		if greenLap < lapCount then
			greenCheck = 0
			greenLap = greenLap + 1
			helper.flashUiMessage('Green Lap!', 3)
		elseif greenLap >= lapCount then
			success('green')
		end
	elseif data.subjectName == 'YellowCar' and yellowCheck == 2 then
		if yellowLap < lapCount then
			yellowCheck = 0
			yellowLap = yellowLap + 1
			helper.flashUiMessage('Yellow Lap!', 3)
		elseif yellowLap >= lapCount then
			success('yellow')
		end
	end
end

function onCorner(data)
	
	if data.subjectName == 'RedCar' and redCheck == 0 then
		redCheck = 1
	elseif data.subjectName == 'BlueCar' and blueCheck == 0 then
		blueCheck = 1
	elseif data.subjectName == 'GreenCar' and greenCheck == 0 then
		greenCheck = 1
	elseif data.subjectName == 'YellowCar' and yellowCheck == 0 then
		yellowCheck = 1
	end
end

function onChicane(data)
	if data.subjectName == 'RedCar' and redCheck == 1 then
		redCheck = 2
	elseif data.subjectName == 'BlueCar' and blueCheck == 1 then
		blueCheck = 2
	elseif data.subjectName == 'GreenCar' and greenCheck == 1 then
		greenCheck = 2
	elseif data.subjectName == 'YellowCar' and yellowCheck == 1 then
		yellowCheck = 2
	end
end

local function onRaceTick(raceTickTime)
	if not running then
        return true
    end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick

return M